﻿Option Strict On

Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols

' To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line.
' <System.Web.Script.Services.ScriptService()> _
<WebService(Namespace:="http://concurrencyserver.desaware.com/")> _
<WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
<Global.Microsoft.VisualBasic.CompilerServices.DesignerGenerated()> _
Public Class Licenser
    Inherits System.Web.Services.WebService

    ' Allocate's a license 
    <WebMethod()> _
    Public Function AllocateLicense(ByVal cert As String, ByVal LicenseLifetime As Integer, ByRef InstallCode As String, ByRef UniqueCode As String) As ConcurrencyResults
        SyncLock Application
            Dim cm As ConcurrencyManager = GetCM()
            'If Not Diagnostics.Debugger.IsAttached Then
            '    Diagnostics.Debugger.Launch()
            '    Diagnostics.Debugger.Break()
            'End If
            Dim cmr As ConcurrencyResults = cm.ParseCertificate(cert, LicenseLifetime, InstallCode, UniqueCode)
            If cmr = ConcurrencyResults.Success Then
                Return cm.Allocate(InstallCode, UniqueCode)
            End If
            Return cmr
        End SyncLock

    End Function


    <WebMethod()> _
    Public Function AllocateTest(ByVal LicenseLifetime As Integer, ByRef InstallCode As String, ByRef UniqueCode As String) As ConcurrencyResults
        SyncLock Application
            'Dim cm As ConcurrencyManager = GetCM()
            'Return cm.Allocate(InstallCode, UniqueCode)
            Return ConcurrencyResults.FunctionDisabled
        End SyncLock
    End Function

    <WebMethod()> _
    Public Function Renew(ByVal InstallCode As String, ByVal UniqueInstall As String) As ConcurrencyResults
        SyncLock Application
            Dim cm As ConcurrencyManager = GetCM()
            Return cm.Renew(InstallCode, UniqueInstall)
        End SyncLock

    End Function

    <WebMethod()> _
    Public Function Release(ByVal InstallCode As String, ByVal UniqueInstall As String) As ConcurrencyResults
        SyncLock Application
            Dim cm As ConcurrencyManager = GetCM()
            Return cm.Release(InstallCode, UniqueInstall)
        End SyncLock

    End Function




    Private Function GetCM() As ConcurrencyManager
        Dim cm As ConcurrencyManager = CType(Application.Item("CM"), ConcurrencyManager)
        If cm Is Nothing Then
            cm = New ConcurrencyManager
            Application.Item("CM") = cm
        End If
        Return cm

    End Function

End Class
