'=====================================================================
' This file is part of the Desaware Licensing System samples.
'
' Copyright 2008 Desaware Inc. All rights reserved.
'
'THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
'KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
'IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
'PARTICULAR PURPOSE.
'=====================================================================
' Desaware Licensing System HighSecurity sample project, form1.vb file.
' Copyright 2003-2004 by Desaware Inc. All Rights Reserved
' www.desaware.com
Option Strict On
Option Explicit On 

' This sample demonstrates how to implement a high security licensing scheme
' using the Desaware Licensing System.
Imports Desaware.MachineLicense20
Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents CodeEntryControl1 As Desaware.MachineLicense20.CodeEntryControl
    Friend WithEvents ClientLicense1 As Desaware.MachineLicense20.ClientLicense
    Friend WithEvents lblLicensed As System.Windows.Forms.Label
    Friend WithEvents cmdInstall As System.Windows.Forms.Button
    Friend WithEvents LicenseTimer As System.Windows.Forms.Timer
    Friend WithEvents Label1 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(Form1))
        Me.CodeEntryControl1 = New Desaware.MachineLicense20.CodeEntryControl
        Me.ClientLicense1 = New Desaware.MachineLicense20.ClientLicense(Me.components)
        Me.lblLicensed = New System.Windows.Forms.Label
        Me.cmdInstall = New System.Windows.Forms.Button
        Me.Label1 = New System.Windows.Forms.Label
        Me.LicenseTimer = New System.Windows.Forms.Timer(Me.components)
        Me.SuspendLayout()
        '
        'CodeEntryControl1
        '
        Me.CodeEntryControl1.License = Nothing
        Me.CodeEntryControl1.Location = New System.Drawing.Point(16, 76)
        Me.CodeEntryControl1.Name = "CodeEntryControl1"
        Me.CodeEntryControl1.Size = New System.Drawing.Size(353, 20)
        Me.CodeEntryControl1.TabIndex = 0
        Me.CodeEntryControl1.ToolTip = Nothing
        '
        'ClientLicense1
        '
        Me.ClientLicense1.ApplicationName = Nothing
        Me.ClientLicense1.CustomData = Nothing
        Me.ClientLicense1.LicenseServers = Nothing
        Me.ClientLicense1.PublicKey = Nothing
        Me.ClientLicense1.ResourceName = "mytestapp"
        '
        'lblLicensed
        '
        Me.lblLicensed.Location = New System.Drawing.Point(16, 108)
        Me.lblLicensed.Name = "lblLicensed"
        Me.lblLicensed.Size = New System.Drawing.Size(452, 32)
        Me.lblLicensed.TabIndex = 1
        '
        'cmdInstall
        '
        Me.cmdInstall.Location = New System.Drawing.Point(388, 76)
        Me.cmdInstall.Name = "cmdInstall"
        Me.cmdInstall.Size = New System.Drawing.Size(75, 23)
        Me.cmdInstall.TabIndex = 2
        Me.cmdInstall.Text = "Install"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(12, 4)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(468, 64)
        Me.Label1.TabIndex = 3
        Me.Label1.Text = resources.GetString("Label1.Text")
        '
        'LicenseTimer
        '
        Me.LicenseTimer.Interval = 10000
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(484, 145)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.cmdInstall)
        Me.Controls.Add(Me.lblLicensed)
        Me.Controls.Add(Me.CodeEntryControl1)
        Me.Name = "Form1"
        Me.Text = "High Security Example"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private ServerData As IDictionary
    Private concurrencyserver As concurrencymanager.Licenser
    Private m_icode As String, m_ucode As String

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        LicenseTimer.Enabled = False
        If concurrencyserver IsNot Nothing Then
            Try
                concurrencyserver.Release(m_icode, m_ucode)
            Catch ex As Exception

            End Try
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim vlresults As ValidationStatus

        ' Our sample will also require an active internet connection if
        ' running in demo mode. This is used to retrieve the current date/time
        ' from an external source so that the user cannot simply change their
        ' system date to extend their demo.
        ClientLicense1.DemoRequireInternet = True
        vlresults = ClientLicense1.VerifyLicense(True)

        ' Check to see if we have a valid "signed" license file (this means that we
        ' will not accept "TempSuccess" since that indicates an unsigned license file).
        If vlresults = ValidationStatus.Success Then
            If ClientLicense1.Licensed Then
                Try
                    ServerData = ParseServerData(ClientLicense1.Certificate)
                Catch ex As Exception
                    Throw New Exception("Certificate server data is missing or corrupt")
                End Try

                If ServerData.Contains("ExpirationDate") Then
                    Dim ExpirationDate As Date = CDate(ServerData.Item("ExpirationDate"))
                    Dim baddate As Date = Nothing
                    Dim refdate As Date = ClientLicense1.GetInternetTime(500)
                    If refdate > baddate AndAlso Now.AddDays(1) < refdate Then
                        Throw New Exception("The system date is not accurate. The program cannot continue")
                    End If

                    If ExpirationDate >= Now Then
                        lblLicensed.Text = "Application is licensed"
                    Else
                        lblLicensed.Text = "License has expired"
                    End If
                End If
                If ServerData.Contains("ConcurrencyServer") Then    ' Concurrency is active
                    concurrencyserver = New concurrencymanager.Licenser()
                    concurrencyserver.Url = CStr(ServerData.Item("ConcurrencyServer"))
                    Dim lease As concurrencymanager.ConcurrencyResults = concurrencyserver.AllocateLicense(ClientLicense1.Certificate.OuterXml, 60, m_icode, m_ucode)
                    If lease = concurrencymanager.ConcurrencyResults.Success Then
                        lblLicensed.Text = "Application is licensed - lease acquired"
                        LicenseTimer.Enabled = True
                    Else
                        lblLicensed.Text = "Lease not acquired: " & lease.ToString
                    End If
                End If
            Else
                If ClientLicense1.DemoVersion Then
                    lblLicensed.Text = "Application is a demo version"
                Else
                    lblLicensed.Text = "Application is not licensed"
                    Exit Sub
                End If
            End If
        Else
            If vlresults = ValidationStatus.TempSuccess Then
                lblLicensed.Text = "Application is not licensed - requires server activation."
                LicenseTimer.Enabled = True
            Else
                lblLicensed.Text = "Application is not licensed - " & ClientLicense1.GetResultDescription(vlresults)
            End If
        End If

    End Sub

    Public Shared Function ParseServerData(ByVal xdoc As Xml.XmlDocument) As IDictionary
        Dim sv As String = xdoc.GetElementsByTagName("ServerData").Item(0).FirstChild.Value
        Dim b As Byte() = Convert.FromBase64String(sv)
        Dim ms As New IO.MemoryStream(b)
        Dim serverdata As IDictionary = Desaware.DLSextensions.DictionarySerializer.Deserialize(ms)
        Return serverdata
    End Function

    Private Sub cmdInstall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdInstall.Click
        Dim results As InstallErrorResults
        If CodeEntryControl1.InstallCode = "" Then
            results = ClientLicense1.InstallDemo(InstallationModes.SyncActivationRequired)
        Else
            results = ClientLicense1.InstallLicense(CodeEntryControl1.InstallCode, InstallationModes.SyncActivationRequired)
        End If

        If results > InstallErrorResults.FatalError OrElse results = InstallErrorResults.NoLicenseServers Then
            MsgBox(ClientLicense1.GetResultDescription(results))
            lblLicensed.Text = ""
        Else
            lblLicensed.Text = "Installation Successful (restart application to see status)"
        End If
    End Sub

    Private Sub LicenseTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LicenseTimer.Tick
        Static intick As Boolean
        If intick Then Exit Sub
        intick = True
        Try
            Dim result As concurrencymanager.ConcurrencyResults = concurrencyserver.Renew(m_icode, m_ucode)
            If result <> concurrencymanager.ConcurrencyResults.Success Then
                ' Try to reacquire
                ' We reacquire because it's possible for a server to do a restart
                Dim newresult As concurrencymanager.ConcurrencyResults = concurrencyserver.AllocateLicense(ClientLicense1.Certificate.OuterXml, 60, m_icode, m_ucode)
                If newresult <> concurrencymanager.ConcurrencyResults.Success Then
                    If lblLicensed.Text <> "License lease lost" Then
                        MsgBox("License lease lost: " & newresult.ToString)
                        lblLicensed.Text = "License lease lost"
                    End If
                    ' What would you like to do here?
                Else
                    lblLicensed.Text = "Application is licensed - lease acquired"
                End If
                Exit Sub
            End If
        Catch ex As Exception
            ' What would you like to do here?
        Finally
            intick = False
        End Try
    End Sub
End Class
