﻿Imports System.Xml

Partial Class dlsextdefault
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Protected Sub cmdGetExpiration_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdGetExpiration.Click
        Dim m As New dlsextmanagement()
        If txtKey.Text = "" Then
            lblCurrent.Text = "Invalid key"
            Exit Sub
        End If
        Dim d As Date = m.GetExpirationDate(txtKey.Text)
        If d = Date.MaxValue Then
            lblCurrent.Text = "Never expires"
            Exit Sub
        End If
        lblCurrent.Text = "Expires: " & d.ToLongDateString
        Calendar1.SelectedDate = d
        Calendar1.VisibleDate = d
        m.Dispose()
    End Sub

    Protected Sub cmdSetExpiration_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdSetExpiration.Click
        Dim m As New dlsextmanagement()
        If txtKey.Text = "" Then
            lblCurrent.Text = "Invalid key"
            Exit Sub
        End If
        m.SetExpirationDate(txtKey.Text, Calendar1.SelectedDate)

        Dim d As Date = m.GetExpirationDate(txtKey.Text)
        If d = Date.MaxValue Then
            lblCurrent.Text = "Never expires"
            Exit Sub
        End If
        lblCurrent.Text = "Expires: " & d.ToLongDateString
        m.Dispose()
    End Sub

    Protected Sub cmdGetCurrentExpiration_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdGetCurrentExpiration.Click
        Dim d As Date
        Dim m As New dlsextmanagement()
        If txtUniqueInstall.Text <> "" Then
            d = m.GetCurrentDemoExpirationDate(txtUniqueInstall.Text)
        Else
            Dim ute As New UTF8Encoding()
            Try
                If fileUniqueInstall.FileBytes.Length = 0 Then
                    lblCurrentExpiration.Text = "Set a Install GUID or upload a certificate"
                    Exit Sub
                End If
                Dim cert As String = ute.GetChars(fileUniqueInstall.FileBytes)
                Dim xd As New XmlDocument()
                xd.LoadXml(cert)
                Dim uiguid As String = xd.GetElementsByTagName("UniqueInstallation").Item(0).Item("GUID").FirstChild.Value
                d = m.GetCurrentDemoExpirationDate(uiguid)
            Catch ex As Exception
                lblCurrentExpiration.Text = "Invalid certificate"
                Exit Sub
            End Try
        End If
        If d = Nothing Then
            lblCurrentExpiration.Text = "Specified UniqueInstall value not found in the database"
        Else
            lblCurrentExpiration.Text = d.ToLongDateString
            calDemoExpiration.SelectedDate = d
            calDemoExpiration.VisibleDate = d
        End If
        m.Dispose()
    End Sub

    Protected Sub cmdGetNewDLSC_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdGetNewDLSC.Click
        Dim m As New dlsextmanagement()
        Dim ute As New UTF8Encoding()
        Try
            If fileUniqueInstall.FileBytes.Length = 0 Then
                lblSetDateError.Text = "Please specify a file path"
                Exit Sub
            End If
            Dim cert As String = ute.GetChars(fileUniqueInstall.FileBytes)

            Dim xd As New XmlDocument()
            xd.LoadXml(cert)
            Dim uiguid As String = xd.GetElementsByTagName("UniqueInstallation").Item(0).Item("GUID").FirstChild.Value
            Dim d As Date = m.GetCurrentDemoExpirationDate(uiguid)
            If calDemoExpiration.SelectedDate < d Then
                lblSetDateError.Text = "Can't reduce the demo period"
                Exit Sub
            End If
            m.ExtendDemo(uiguid, calDemoExpiration.SelectedDate)

            Dim newcert As String = m.StripXmlSignature(cert)
            Response.ContentType = "application/octet-stream"
            Response.AppendHeader("Content-Disposition", "attachment;filename=" & fileUniqueInstall.FileName)
            Response.Write(newcert)
            Response.Flush()
            Response.End()
        Catch ex As Exception
            lblSetDateError.Text = "Unable to strip certificate (may already be unsigned?): " & ex.Message
        Finally
            m.Dispose()
        End Try

    End Sub

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Response.Redirect("concurrency.aspx")
    End Sub
End Class
