﻿Imports System.Xml
Imports System.Xml.Serialization

Public Class DictionarySerializer
    Implements Serialization.IXmlSerializable

    Private m_dictionary As IDictionary

    Public Sub New()
        m_dictionary = New Hashtable
    End Sub

    Public Sub New(ByVal sourcedictionary As IDictionary)
        m_dictionary = sourcedictionary
    End Sub

    Public Shared Sub Serialize(ByVal strm As IO.Stream, ByVal dictionary As IDictionary)
        Dim ds As New DictionarySerializer(dictionary)
        Dim xs As New XmlSerializer(GetType(DictionarySerializer))
        xs.Serialize(strm, ds)
    End Sub

    Public Shared Function Deserialize(ByVal strm As IO.Stream) As IDictionary
        Dim xs As New XmlSerializer(GetType(DictionarySerializer))
        Dim ds As DictionarySerializer = CType(xs.Deserialize(strm), DictionarySerializer)
        Return ds.m_dictionary
    End Function

    Public Function GetSchema() As Xml.Schema.XmlSchema Implements IXmlSerializable.GetSchema
        Return Nothing
    End Function

    Public Sub ReadXml(ByVal reader As Xml.XmlReader) Implements IXmlSerializable.ReadXml
        reader.Read()
        reader.ReadStartElement("dictionary")
        While reader.NodeType <> XmlNodeType.EndElement
            reader.ReadStartElement("item")
            Dim key As String = reader.ReadElementString("key")
            Dim value As String = reader.ReadElementString("value")
            reader.ReadEndElement()
            reader.MoveToContent()
            m_dictionary.Add(key, value)

        End While
        reader.ReadEndElement()
    End Sub

    Public Sub WriteXml(ByVal writer As XmlWriter) Implements IXmlSerializable.WriteXml
        writer.WriteStartElement("dictionary")
        For Each key As Object In m_dictionary.Keys
            Dim value As Object = m_dictionary.Item(key)
            writer.WriteStartElement("item")
            writer.WriteElementString("key", key.ToString())
            writer.WriteElementString("value", value.ToString())
            writer.WriteEndElement()
        Next
        writer.WriteEndElement()
    End Sub



End Class
