﻿Public Class NewSystemMatch
    Implements Desaware.Dls.ISystemMatch

    Public Function CheckGeneralMatch(ByVal Identifiers() As Desaware.Dls.SystemIdentifierInfo, ByVal ExistingEntries() As Desaware.Dls.SystemIdentifierInfo, ByVal democompare As Boolean) As Boolean
        Dim nametested As New Dictionary(Of String, Integer)
        Dim matchfound As Integer
        For Each thisidentifier As Desaware.Dls.SystemIdentifierInfo In Identifiers
            matchfound = 0
            For Each existingidentifier As Desaware.Dls.SystemIdentifierInfo In ExistingEntries
                If thisidentifier.Name = existingidentifier.Name AndAlso thisidentifier.Value = existingidentifier.Value Then
                    matchfound = 1
                End If
            Next
            If Not nametested.ContainsKey(thisidentifier.Name) Then
                nametested.Add(thisidentifier.Name, matchfound)
            End If
            If matchfound <> 0 Then
                nametested.Item(thisidentifier.Name) = nametested.Item(thisidentifier.Name) + 1
            End If
        Next

        ' Now nametested contains a list of all current identifiers, each one indicating the # of matches found in the existing identifier list
        ' For demo match, each identifier name must have at least one match
        If democompare Then
            For Each key As String In nametested.Keys
                If nametested.Item(key) = 0 Then Return False
            Next
            Return True
        End If

        ' For install compare we'll allow one difference, but at least one NICMAC must match
        Dim comparecount As Integer

        For Each key As String In nametested.Keys
            If nametested.Item(key) > 0 Then comparecount += 1
        Next

        If nametested.Item("NICMAC") = 0 Then Return False
        If comparecount < nametested.Count - 1 Then
            Return False
        End If
        Return True

    End Function


    Public Function CheckDemoMatch(ByVal Identifiers() As Desaware.Dls.SystemIdentifierInfo, ByVal ExistingEntries() As Desaware.Dls.SystemIdentifierInfo) As Boolean Implements Desaware.Dls.ISystemMatch.CheckDemoMatch
        Return CheckGeneralMatch(Identifiers, ExistingEntries, True)

    End Function

    Public Function CheckInstallationMatch(ByVal Identifiers() As Desaware.Dls.SystemIdentifierInfo, ByVal ExistingEntries() As Desaware.Dls.SystemIdentifierInfo) As Boolean Implements Desaware.Dls.ISystemMatch.CheckInstallationMatch
        Return CheckGeneralMatch(Identifiers, ExistingEntries, False)
    End Function





End Class

#If SERVER Then

Public Class ServerData
    Public Function ProvideServerData(ByVal appname As String, ByVal UniqueGuid As String, ByVal InstallationCode As String, ByVal CustomData As Specialized.StringDictionary) As Byte()
        'If Not Diagnostics.Debugger.IsAttached Then Diagnostics.Debugger.Launch()
        'Diagnostics.Debugger.Break()
        Dim connect As String = Configuration.ConfigurationManager.AppSettings("connectionstring")
        Dim connecttype As String = Configuration.ConfigurationManager.AppSettings("connectiontype")
        Dim dbl As New dblink(connect, connecttype)

        Dim thedate As Date = dbl.GetExpirationDate(InstallationCode)
        ' We pull this out because this version does not force an expiration date
        'If thedate >= Date.MaxValue Then
        '    thedate = Now.AddYears(1)
        '    dbl.SetExpirationDate(InstallationCode, thedate)  ' If you forget to set the date, expire at 1 year
        'End If

        Dim server As String = Nothing, count As Integer
        Dim concurrencyenabled As Boolean = dbl.GetConcurrencyInfo(InstallationCode, server, count)

        dbl.Dispose()

        ' We now serialize in a Hashtable to allow more flexible use of server data
        Dim dataholder As New Hashtable()
        If thedate <> Date.MaxValue Then dataholder.Add("Expirationdate", thedate)
        If concurrencyenabled Then
            dataholder.Add("ConcurrencyServer", server)
            dataholder.Add("ConcurrencyCount", count)
            dataholder.Add("ConcurrencyDate", Now)
            dataholder.Add("InstallationCode", InstallationCode)
        End If

        Dim ms As New IO.MemoryStream
        DictionarySerializer.Serialize(ms, dataholder)
        ms.Flush()
        Return (ms.ToArray())
    End Function

End Class
#End If
